if select(6, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING" then return end

local SEED_CLASS = {
	"WARRIOR",
	"MAGE",
	"ROGUE",
	"DRUID",
	"HUNTER",
	"SHAMAN",
	"PRIEST",
	"WARLOCK",
	"PALADIN",
	"DEATHKNIGHT",
}

local CLASS_TEX_COORDS = {
	WARRIOR     = {0, 0.25, 0, 0.25},
	MAGE        = {0.25, 0.49609375, 0, 0.25},
	ROGUE       = {0.49609375, 0.7421875, 0, 0.25},
	DRUID       = {0.7421875, 0.98828125, 0, 0.25},
	HUNTER      = {0, 0.25, 0.25, 0.5},
	SHAMAN      = {0.25, 0.49609375, 0.25, 0.5},
	PRIEST      = {0.49609375, 0.7421875, 0.25, 0.5},
	WARLOCK     = {0.7421875, 0.98828125, 0.25, 0.5},
	PALADIN     = {0, 0.25, 0.5, 0.75},
	DEATHKNIGHT = {0.25, 0.49609375, 0.5, 0.75},
}

local PitBull4 = _G.PitBull4
if not PitBull4 then
	error("PitBull4_ClassIcon requires PitBull4")
end

local L = PitBull4.L

local PitBull4_ClassIcon = PitBull4:NewModule("ClassIcon", "AceEvent-3.0")

PitBull4_ClassIcon:SetModuleType("indicator")
PitBull4_ClassIcon:SetName(L["Class icon"])
PitBull4_ClassIcon:SetDescription(L["Shows an class icon on the unit frame."])
PitBull4_ClassIcon:SetDefaults({
	attach_to = "root",
	location = "edge_bottom_left",
	position = 1,
})

function PitBull4_ClassIcon:GetTexture(frame)
	return [[Interface\Glues\CharacterCreate\UI-CharacterCreate-Classes]]
end

function PitBull4_ClassIcon:GetExampleTexture(frame)
	return [[Interface\Glues\CharacterCreate\UI-CharacterCreate-Classes]]
end

function PitBull4_ClassIcon:GetTexCoord(frame, texture)
	local _, class = UnitClass(frame.unit)
	if class then
		return CLASS_TEX_COORDS[class][1], CLASS_TEX_COORDS[class][2], CLASS_TEX_COORDS[class][3], CLASS_TEX_COORDS[class][4]
	else --config
		local seed = SEED_CLASS[random(10)]
		return CLASS_TEX_COORDS[seed][1], CLASS_TEX_COORDS[seed][2], CLASS_TEX_COORDS[seed][3], CLASS_TEX_COORDS[seed][4]
	end
end
